# coding: utf-8

# flake8: noqa
"""
    DNS Configuration API

    The DNS application is a Universal DDI service that provides cloud-based DNS configuration with on-prem host serving DNS protocol. It is part of the full-featured Universal DDI solution that enables customers the ability to deploy large numbers of protocol servers in the delivery of DNS and DHCP throughout their enterprise network.   

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

# import models into model package
from dns_config.models.acl import ACL
from dns_config.models.acl_item import ACLItem
from dns_config.models.auth_nsg import AuthNSG
from dns_config.models.auth_zone import AuthZone
from dns_config.models.auth_zone_config import AuthZoneConfig
from dns_config.models.auth_zone_external_provider import AuthZoneExternalProvider
from dns_config.models.auth_zone_inheritance import AuthZoneInheritance
from dns_config.models.bulk_copy_error import BulkCopyError
from dns_config.models.bulk_copy_response import BulkCopyResponse
from dns_config.models.bulk_copy_view import BulkCopyView
from dns_config.models.cache_flush import CacheFlush
from dns_config.models.convert_domain_name import ConvertDomainName
from dns_config.models.convert_domain_name_response import ConvertDomainNameResponse
from dns_config.models.convert_r_name_response import ConvertRNameResponse
from dns_config.models.copy_auth_zone import CopyAuthZone
from dns_config.models.copy_auth_zone_response import CopyAuthZoneResponse
from dns_config.models.copy_forward_zone import CopyForwardZone
from dns_config.models.copy_forward_zone_response import CopyForwardZoneResponse
from dns_config.models.copy_response import CopyResponse
from dns_config.models.create_acl_response import CreateACLResponse
from dns_config.models.create_auth_nsg_response import CreateAuthNSGResponse
from dns_config.models.create_auth_zone_response import CreateAuthZoneResponse
from dns_config.models.create_delegation_response import CreateDelegationResponse
from dns_config.models.create_forward_nsg_response import CreateForwardNSGResponse
from dns_config.models.create_forward_zone_response import CreateForwardZoneResponse
from dns_config.models.create_lbdn_response import CreateLBDNResponse
from dns_config.models.create_server_response import CreateServerResponse
from dns_config.models.create_view_response import CreateViewResponse
from dns_config.models.custom_root_ns_block import CustomRootNSBlock
from dns_config.models.dns_global import DNSGlobal
from dns_config.models.dnssec_validation_block import DNSSECValidationBlock
from dns_config.models.dtc_config import DTCConfig
from dns_config.models.dtc_policy import DTCPolicy
from dns_config.models.delegation import Delegation
from dns_config.models.delegation_server import DelegationServer
from dns_config.models.display_view import DisplayView
from dns_config.models.ecs_block import ECSBlock
from dns_config.models.ecs_zone import ECSZone
from dns_config.models.external_primary import ExternalPrimary
from dns_config.models.external_secondary import ExternalSecondary
from dns_config.models.forward_nsg import ForwardNSG
from dns_config.models.forward_zone import ForwardZone
from dns_config.models.forward_zone_config import ForwardZoneConfig
from dns_config.models.forwarder import Forwarder
from dns_config.models.forwarders_block import ForwardersBlock
from dns_config.models.host import Host
from dns_config.models.host_associated_server import HostAssociatedServer
from dns_config.models.host_inheritance import HostInheritance
from dns_config.models.inheritance2_assigned_host import Inheritance2AssignedHost
from dns_config.models.inheritance2_inherited_bool import Inheritance2InheritedBool
from dns_config.models.inheritance2_inherited_string import Inheritance2InheritedString
from dns_config.models.inheritance2_inherited_u_int32 import Inheritance2InheritedUInt32
from dns_config.models.inherited_acl_items import InheritedACLItems
from dns_config.models.inherited_custom_root_ns_block import InheritedCustomRootNSBlock
from dns_config.models.inherited_dnssec_validation_block import InheritedDNSSECValidationBlock
from dns_config.models.inherited_dtc_config import InheritedDtcConfig
from dns_config.models.inherited_ecs_block import InheritedECSBlock
from dns_config.models.inherited_forwarders_block import InheritedForwardersBlock
from dns_config.models.inherited_kerberos_keys import InheritedKerberosKeys
from dns_config.models.inherited_sort_list_items import InheritedSortListItems
from dns_config.models.inherited_zone_authority import InheritedZoneAuthority
from dns_config.models.inherited_zone_authority_m_name_block import InheritedZoneAuthorityMNameBlock
from dns_config.models.internal_secondary import InternalSecondary
from dns_config.models.kerberos_key import KerberosKey
from dns_config.models.lbdn import LBDN
from dns_config.models.list_acl_response import ListACLResponse
from dns_config.models.list_auth_nsg_response import ListAuthNSGResponse
from dns_config.models.list_auth_zone_response import ListAuthZoneResponse
from dns_config.models.list_delegation_response import ListDelegationResponse
from dns_config.models.list_forward_nsg_response import ListForwardNSGResponse
from dns_config.models.list_forward_zone_response import ListForwardZoneResponse
from dns_config.models.list_host_response import ListHostResponse
from dns_config.models.list_lbdn_response import ListLBDNResponse
from dns_config.models.list_server_response import ListServerResponse
from dns_config.models.list_view_response import ListViewResponse
from dns_config.models.read_acl_response import ReadACLResponse
from dns_config.models.read_auth_nsg_response import ReadAuthNSGResponse
from dns_config.models.read_auth_zone_response import ReadAuthZoneResponse
from dns_config.models.read_delegation_response import ReadDelegationResponse
from dns_config.models.read_forward_nsg_response import ReadForwardNSGResponse
from dns_config.models.read_forward_zone_response import ReadForwardZoneResponse
from dns_config.models.read_global_response import ReadGlobalResponse
from dns_config.models.read_host_response import ReadHostResponse
from dns_config.models.read_lbdn_response import ReadLBDNResponse
from dns_config.models.read_server_response import ReadServerResponse
from dns_config.models.read_view_response import ReadViewResponse
from dns_config.models.root_ns import RootNS
from dns_config.models.server import Server
from dns_config.models.server_inheritance import ServerInheritance
from dns_config.models.sort_list_item import SortListItem
from dns_config.models.tsig_key import TSIGKey
from dns_config.models.ttl_inheritance import TTLInheritance
from dns_config.models.trust_anchor import TrustAnchor
from dns_config.models.update_acl_response import UpdateACLResponse
from dns_config.models.update_auth_nsg_response import UpdateAuthNSGResponse
from dns_config.models.update_auth_zone_response import UpdateAuthZoneResponse
from dns_config.models.update_delegation_response import UpdateDelegationResponse
from dns_config.models.update_forward_nsg_response import UpdateForwardNSGResponse
from dns_config.models.update_forward_zone_response import UpdateForwardZoneResponse
from dns_config.models.update_global_response import UpdateGlobalResponse
from dns_config.models.update_host_response import UpdateHostResponse
from dns_config.models.update_lbdn_response import UpdateLBDNResponse
from dns_config.models.update_server_response import UpdateServerResponse
from dns_config.models.update_view_response import UpdateViewResponse
from dns_config.models.view import View
from dns_config.models.view_inheritance import ViewInheritance
from dns_config.models.warning import Warning
from dns_config.models.zone_authority import ZoneAuthority
from dns_config.models.zone_authority_m_name_block import ZoneAuthorityMNameBlock
