# coding: utf-8

"""
    IP Address Management API

    The IPAM/DHCP Application is a Universal DDI service providing IP address management and DHCP protocol features. The IPAM component provides visibility into and provisioning tools to manage networking spaces, monitoring and reporting of entire IP address infrastructures, and integration with DNS and DHCP protocols. The DHCP component provides DHCP protocol configuration service with on-prem host serving DHCP protocol. It is part of the full-featured, DDI cloud solution that enables customers to deploy large numbers of protocol servers to deliver DNS and DHCP throughout their enterprise network.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

import unittest

from ipam.api.address_block_api import AddressBlockApi

from universal_ddi_client.api_client import ApiClient


class TestAddressBlockApi(unittest.TestCase):
    """AddressBlockApi unit test stubs"""

    def setUp(self) -> None:
        api_instance = ApiClient()
        self.api = AddressBlockApi(api_instance)

    def tearDown(self) -> None:
        pass

    def test_copy(self) -> None:
        """Test case for copy

        Copy the address block.
        """
        pass

    def test_create(self) -> None:
        """Test case for create

        Create the address block.
        """
        pass

    def test_create_next_available_ab(self) -> None:
        """Test case for create_next_available_ab

        Create the Next Available Address Block object.
        """
        pass

    def test_create_next_available_ip(self) -> None:
        """Test case for create_next_available_ip

        Allocate the next available IP address.
        """
        pass

    def test_create_next_available_subnet(self) -> None:
        """Test case for create_next_available_subnet

        Create the Next Available Subnet object.
        """
        pass

    def test_delete(self) -> None:
        """Test case for delete

        Move the address block to the recycle bin.
        """
        pass

    def test_list(self) -> None:
        """Test case for list

        Retrieve the address blocks.
        """
        pass

    def test_list_ancestor(self) -> None:
        """Test case for list_ancestor

        Retrieve address block ancestors.
        """
        pass

    def test_list_next_available_ab(self) -> None:
        """Test case for list_next_available_ab

        List Next Available Address Block objects.
        """
        pass

    def test_list_next_available_ip(self) -> None:
        """Test case for list_next_available_ip

        Retrieve the next available IP address.
        """
        pass

    def test_list_next_available_subnet(self) -> None:
        """Test case for list_next_available_subnet

        List Next Available Subnet objects.
        """
        pass

    def test_read(self) -> None:
        """Test case for read

        Retrieve the address block.
        """
        pass

    def test_update(self) -> None:
        """Test case for update

        Update the address block.
        """
        pass


if __name__ == '__main__':
    unittest.main()
